#!/bin/bash

set -ex

# ImgDownload.sh

# $1 : serial device
# $2 : local path to binary
# $3 : binary
######



# Duration()

# $1 : local path to binary
# $2 : binary
######

function Duration () {

	# BAUD=115200

	# D = B*n / (n+b)
	# B = 115200 Baud
	# n = 8 bits   (application data bits)
	# b = 4 bits   (overhead bits: 1x start bit, 1x parity bit, 2x stop bit)
	### TODO: use theoric calculation

	BAUD=40000   	# 60% margin from theoric value: 
			# better to try to finish even if a bit long !!
			# BAUD reduced from 80000 to 40000 since we sometime observe low data rate on serial link over ST-Link Virtual COM Port

	/bin/ls -l "$1$2"  > /tmp/IDD$$
	BYTE=`awk '{ print $5 }' /tmp/IDD$$`
	BIT=`echo $(($BYTE*10))`
	SEC=`echo $(($BIT/$BAUD))`
	
	/bin/rm -f /tmp/IDD$$
}



MINICOM_CFG=5:0:1cb2:0:3:1c:7f:15:4:2:0:0:11:13:1a:0:12:f:17:16:0:0:0:0:0:0:0:0:0:0:0:0:0:0:0:0


if [ $# -ne 3 ]
then
	echo "$0: tty file"
else
	/bin/stty -F "$1" $MINICOM_CFG &
	# first setup fails after PC reboot...
	/bin/sleep 1
	/bin/stty -F "$1" $MINICOM_CFG
	
	if [ $? -ne 0 ]
	then
		# may fail the first time ...
		/bin/stty -F "$1" $MINICOM_CFG	
	fi
   	# slattach -Ld -s 115200 -p tty "$1"
	{
		echo -e "root\r"	#login
		echo -e "\r"  		#password
		echo -e "mkdir -p /lib/firmware\r"  
		echo -e "cd /lib/firmware\r"  
		echo -e "rm \"$3\"\r"  
   		sleep 1
	} > "$1"

	# need to try sz
	REMOTE_TMP_FILE=tmp_file$$
	LOCAL_TMP_FILE=/tmp/$REMOTE_TMP_FILE
#	echo try > $LOCAL_TMP_FILE
#	/usr/bin/sz --zmodem -b $LOCAL_TMP_FILE > "$1" < "$1"
#	echo Return code first sz $?
#	echo -e "rm $REMOTE_TMP_FILE\r" > "$1" 

	Duration "$2" "$3"
	timeout $SEC /usr/bin/sz --zmodem -b "$2$3" > "$1" < "$1"
	echo Return code second sz $?


fi