#!/bin/bash

set -ex

# ImgDownload.sh

# $1 : serial device
# $2 : local path to binary
# $3 : binary
# $4 : project path on target
######



# Duration()

# $1 : local path to binary
# $2 : binary
######

function Duration () {

	# BAUD=115200

	# D = B*n / (n+b)
	# B = 115200 Baud
	# n = 8 bits   (application data bits)
	# b = 4 bits   (overhead bits: 1x start bit, 1x parity bit, 2x stop bit)
	### TODO: use theoric calculation

	BAUD=40000   	# 60% margin from theoric value: 
			# better to try to finish even if a bit long !!
			# BAUD reduced from 80000 to 40000 since we sometime observe low data rate on serial link over ST-Link Virtual COM Port

	/bin/ls -l "$1$2"  > /tmp/IDD$$
	BYTE=`awk '{ print $5 }' /tmp/IDD$$`
	BIT=`echo $(($BYTE*10))`
	SEC=`echo $(($BIT/$BAUD))`
	
	/bin/rm -f /tmp/IDD$$
}



MINICOM_CFG=5:0:1cb2:0:3:1c:7f:15:4:2:0:0:11:13:1a:0:12:f:17:16:0:0:0:0:0:0:0:0:0:0:0:0:0:0:0:0


if [ $# -ne 4 ]
then
	echo "$0: Bad argument number $#"
else
	/bin/stty -F "$1" $MINICOM_CFG &
	# first setup fails after PC reboot...
	/bin/sleep 1
	/bin/stty -F "$1" $MINICOM_CFG
	
	if [ $? -ne 0 ]
	then
		# may fail the first time ...
		/bin/stty -F "$1" $MINICOM_CFG	
	fi

	echo "Serial Link Download ..."

	# README & fw_cortex_m4.sh
	############
 
	{
		echo -e "root\r"	#login
		echo -e "\r"  		#password
		echo -e "/bin/mkdir -p \"$4\" \r"
		echo -e "cd \"$4\" \r"  
		echo -e "/bin/rm README fw_cortex_m4.sh\r"  # in case it exists
   		sleep 1
	} > "$1"


	# Support for CubeFW directory...
	
	if [ -f "$2"../Remoteproc/README ]
	then
		/usr/bin/sz --zmodem -b "$2"../Remoteproc/README > "$1" < "$1"
	else
		if [ -f "$2"../../../Remoteproc/README ]
		then	
			/usr/bin/dos2unix "$2"../../../Remoteproc/README
			/usr/bin/sz --zmodem -a "$2"../../../Remoteproc/README > "$1" < "$1"
		fi
	fi
	if [ -f "$2"../Remoteproc/fw_cortex_m4.sh ]
	then
		/usr/bin/sz --zmodem -b "$2"../Remoteproc/fw_cortex_m4.sh > "$1" < "$1"
	else
		if [ -f "$2"../../../Remoteproc/fw_cortex_m4.sh ]
		then	
			/usr/bin/dos2unix "$2"../../../Remoteproc/fw_cortex_m4.sh
			/usr/bin/sz --zmodem -a "$2"../../../Remoteproc/fw_cortex_m4.sh > "$1" < "$1"
		fi
	fi


	{
		echo -e "cd \"$4\"/\r"  
		echo -e "/bin/chmod +x fw_cortex_m4.sh\r"  
  		sleep 1
	} > "$1"


	# firmware download
	############

	{
		echo -e "/bin/mkdir -p  lib/firmware \r"
		echo -e "cd lib/firmware\r"  
		echo -e "/bin/rm \"$3\" \r"  
   		sleep 1
	} > "$1"

	Duration "$2" "$3"
	/usr/bin/timeout $SEC /usr/bin/sz --zmodem -b "$2$3" > "$1" < "$1"
	echo Return code second sz $?




fi
