#!/bin/bash

set -ex

# $1 : serial device
# $2 : project    examples/<project> or projects/<projects> 
#                 to be used under /usr/local/

# Exit value : 
#       . 0 : success
#       . 255 : bad parameter
#       . 128 : target access issue

######


TTY=$1

RET=0

if [ $# -ne 2 ]
then
    echo "$0: Bad argument number $#"
    RET=255
else

    # Systematic M4 firmware stop, since no more Deveice Tree overlay to manage ! 
    ###    
    {    
        echo -e "\r" 
        echo -e "echo -n stop >  /sys/class/remoteproc/remoteproc0/state  \r" 
        /bin/sleep 1
    } > "$TTY"   

    # Load the new firmware !
    ###
    {                
        echo -e " \r"  
        echo -e "cd $2/ \r"  
        echo -e "chmod +x fw_cortex_m4.sh  \r"  
        echo -e "./fw_cortex_m4.sh start \r"  
        /bin/sleep 1
    } > "$TTY"

fi

exit $RET
